module arm_pwm(
	clk,
	rst_n,
	uart_date,
	pwmL_A_1,
	pwmL_A_2,
	pwmL_A_3,
	pwmL_B_1,
	pwmL_B_2,
	pwmL_B_3,
	pwmL_C_1,
	pwmL_C_2,
	pwmL_C_3,
	pwmR_A_1,
	pwmR_A_2,
	pwmR_A_3,
	pwmR_B_1,
	pwmR_B_2,
	pwmR_B_3,
	pwmR_C_1,
	pwmR_C_2,
	pwmR_C_3,
	pwm1,
	pwm2,
	pwm3,
	pwm4,
	pwm5,
	pwm6);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input [7:0] uart_date;
	output pwmL_A_1;
	output pwmL_A_2;
	output pwmL_A_3;
	output pwmL_B_1;
	output pwmL_B_2;
	output pwmL_B_3;
	output pwmL_C_1;
	output pwmL_C_2;
	output pwmL_C_3;
	output pwmR_A_1;
	output pwmR_A_2;
	output pwmR_A_3;
	output pwmR_B_1;
	output pwmR_B_2;
	output pwmR_B_3;
	output pwmR_C_1;
	output pwmR_C_2;
	output pwmR_C_3;
	output pwm1;
	output pwm2;
	output pwm3;
	output pwm4;
	output pwm5;
	output pwm6;

	wire clk;
	wire rst_n;
	wire [7:0] uart_date;
	reg pwmL_A_1;
	reg pwmL_A_2;
	reg pwmL_A_3;
	reg pwmL_B_1;
	reg pwmL_B_2;
	reg pwmL_B_3;
	reg pwmL_C_1;
	reg pwmL_C_2;
	reg pwmL_C_3;
	reg pwmR_A_1;
	reg pwmR_A_2;
	reg pwmR_A_3;
	reg pwmR_B_1;
	reg pwmR_B_2;
	reg pwmR_B_3;
	reg pwmR_C_1;
	reg pwmR_C_2;
	reg pwmR_C_3;
	reg pwm1;
	reg pwm2;
	reg pwm3;
	reg pwm4;
	reg pwm5;
	reg pwm6;

	//----Code starts here: integrated by Robei-----
	
	parameter       time20ms    = 1_000_000; 
	parameter       time1s      = 50_000_000;
	parameter       time1_5s    = 75_000_000;
	parameter       time2s      = 100_000_000;
	parameter       time2_5s    = 125_000_000;
	parameter       time3s      = 150_000_000;
	parameter       time3_5s    = 175_000_000;
	parameter       time4s      = 200_000_000;
	parameter       time4_5s    = 225_000_000;
	parameter       time5s      = 250_000_000;
	parameter       time5_5s    = 275_000_000;
	parameter       time6s      = 300_000_000;
	parameter       time6_5s    = 325_000_000;
	parameter       time7s      = 350_000_000;
	parameter       time7_5s    = 350_000_000;
	parameter       time8s      = 400_000_000;
	parameter       time0_5ms   = 25_000;
	parameter       time0_6ms   = 42_000;
	parameter       time0_7ms   = 48_000;
	parameter       time1_0ms   = 50_000;
	parameter       time1_2ms   = 45_000;
	parameter       time1_5ms   = 62_500;
	parameter       time1_7ms   = 80_000;
	parameter       time2_0ms   = 100_000;
	parameter       time2_2ms   = 110_000;
	parameter       time2_5ms   = 125_000;
	
	reg             date_flag_all;
	reg             date_flag_1;
	reg             date_flag_2;
	reg             date_flag_3;
	reg [19:0]      cnt_pwm;
	reg [19:0]      cnt_counter_L_A_1;
	reg [19:0]      cnt_counter_L_A_2;
	reg [19:0]      cnt_counter_L_A_3;
	reg [19:0]      cnt_counter_L_B_1;
	reg [19:0]      cnt_counter_L_B_2;
	reg [19:0]      cnt_counter_L_B_3;
	reg [19:0]      cnt_counter_L_C_1;
	reg [19:0]      cnt_counter_L_C_2;
	reg [19:0]      cnt_counter_L_C_3;
	reg [19:0]      cnt_counter_R_A_1;
	reg [19:0]      cnt_counter_R_A_2;
	reg [19:0]      cnt_counter_R_A_3;
	reg [19:0]      cnt_counter_R_B_1;
	reg [19:0]      cnt_counter_R_B_2;
	reg [19:0]      cnt_counter_R_B_3;
	reg [19:0]      cnt_counter_R_C_1;
	reg [19:0]      cnt_counter_R_C_2;
	reg [19:0]      cnt_counter_R_C_3;
	reg             date_flag_4;
	reg             date_flag_5;
	reg             date_flag_6;
	reg [19:0]      cnt_counter_1;
	reg [19:0]      cnt_counter_2;
	reg [19:0]      cnt_counter_3;
	reg [19:0]      cnt_counter_4;
	reg [19:0]      cnt_counter_5;
	reg [19:0]      cnt_counter_6;
	
	
	
	reg [31:0]      cnt_state;
	reg [ 3:0]      form_state;
	
	/*----------------20msģ-------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			cnt_pwm <= 1'b0;
		end
		else begin
			if(cnt_pwm < time20ms)begin
				cnt_pwm <= cnt_pwm + 1'b1;
			end
			else begin
				cnt_pwm <= 20'd0;
			end
		end
	end
	
	/*----------------pwml_A_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_A_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_A_1)begin
				pwmL_A_1 <= 1'b1;
			end
			else begin
				pwmL_A_1 <= 1'b0;
			end
		end
	end
	/*----------------pwmL_A_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_A_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_A_2)begin
				pwmL_A_2 <= 1'b1;
			end
			else begin
				pwmL_A_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmL_A_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_A_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_A_3)begin
				pwmL_A_3 <= 1'b1;
			end
			else begin
				pwmL_A_3 <= 1'b0;
			end
		end
	end
	
	/*----------------pwmL_B_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_B_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_B_1)begin
				pwmL_B_1 <= 1'b1;
			end
			else begin
				pwmL_B_1 <= 1'b0;
			end
		end
	end
	/*----------------pwml_B_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_B_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_B_2)begin
				pwmL_B_2 <= 1'b1;
			end
			else begin
				pwmL_B_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmL_B_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_B_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_B_3)begin
				pwmL_B_3 <= 1'b1;
			end
			else begin
				pwmL_B_3 <= 1'b0;
			end
		end
	end
	
	/*----------------pwmL_C_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_C_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_C_1)begin
				pwmL_C_1 <= 1'b1;
			end
			else begin
				pwmL_C_1 <= 1'b0;
			end
		end
	end
	/*----------------pwmL_C_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_C_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_C_2)begin
				pwmL_C_2 <= 1'b1;
			end
			else begin
				pwmL_C_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmL_C_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmL_C_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_L_C_3)begin
				pwmL_C_3 <= 1'b1;
			end
			else begin
				pwmL_C_3 <= 1'b0;
			end
		end
	end
	
	/*----------------pwmR_A_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_A_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_A_1)begin
				pwmR_A_1 <= 1'b1;
			end
			else begin
				pwmR_A_1 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_A_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_A_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_A_2)begin
				pwmR_A_2 <= 1'b1;
			end
			else begin
				pwmR_A_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_A_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_A_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_A_3)begin
				pwmR_A_3 <= 1'b1;
			end
			else begin
				pwmR_A_3 <= 1'b0;
			end
		end
	end
	
	/*----------------pwmR_B_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_B_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_B_1)begin
				pwmR_B_1 <= 1'b1;
			end
			else begin
				pwmR_B_1 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_B_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_B_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_B_2)begin
				pwmR_B_2 <= 1'b1;
			end
			else begin
				pwmR_B_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_B_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_B_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_B_3)begin
				pwmR_B_3 <= 1'b1;
			end
			else begin
				pwmR_B_3 <= 1'b0;
			end
		end
	end
	
	/*----------------pwmR_C_1ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_C_1 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_C_1)begin
				pwmR_C_1 <= 1'b1;
			end
			else begin
				pwmR_C_1 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_C_2ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_C_2 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_C_2)begin
				pwmR_C_2 <= 1'b1;
			end
			else begin
				pwmR_C_2 <= 1'b0;
			end
		end
	end
	/*----------------pwmR_C_3ģ---------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			pwmR_C_3 <= 1'b0;
		end
		else begin
			if(cnt_pwm < cnt_counter_R_C_3)begin
				pwmR_C_3 <= 1'b1;
			end
			else begin
				pwmR_C_3 <= 1'b0;
			end
		end
	end
	
	
	
	/*----------------״̬ʱģ------------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			cnt_state  <= 1'b0;
			form_state <= 1'b0;
		end
		else begin
			if(cnt_state < time8s && date_flag_all)begin
				cnt_state <= cnt_state + 1'b1;
				if(cnt_state == time8s-1)begin
					cnt_state  <= 1'd0;
				end
			end
		if(date_flag_1)
			cnt_state <= 1'd0;
		end
	end
	
	/*-------------------״̬ʽģ-------------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			cnt_counter_L_A_1 <= 1'b0;
			cnt_counter_L_A_2 <= 1'b0;
			cnt_counter_L_A_3 <= 1'b0;
			cnt_counter_L_B_1 <= 1'b0;
			cnt_counter_L_B_2 <= 1'b0;
			cnt_counter_L_B_3 <= 1'b0;
			cnt_counter_L_C_1 <= 1'b0;
			cnt_counter_L_C_2 <= 1'b0;
			cnt_counter_L_C_3 <= 1'b0;
			cnt_counter_R_A_1 <= 1'b0;
			cnt_counter_R_A_2 <= 1'b0;
			cnt_counter_R_A_3 <= 1'b0;
			cnt_counter_R_B_1 <= 1'b0;
			cnt_counter_R_B_2 <= 1'b0;
			cnt_counter_R_B_3 <= 1'b0;
			cnt_counter_R_C_1 <= 1'b0;
			cnt_counter_R_C_2 <= 1'b0;
			cnt_counter_R_C_3 <= 1'b0;
		end
		else begin
				if(date_flag_3)begin
					if(cnt_state < time1s)begin                               //1
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_5ms;/**/
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_5ms;/**/
					cnt_counter_R_C_3 <= time2_5ms;
					                               
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_5ms;/**/
					cnt_counter_L_C_3 <= time2_5ms;
					                               
					                               
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					                               
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					                               
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
					end                            
					else if(cnt_state > time1s && cnt_state < time2s)begin //2
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_5ms;/**/
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_5ms;/**/
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_5ms;/**/
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_2ms;/**/
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;/**/
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time0_7ms;/**/
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time2s && cnt_state < time3s)begin //3
					cnt_counter_L_A_1 <= time0_7ms;/**/
					cnt_counter_L_A_2 <= time0_5ms;/**/
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_2ms;/**/
					cnt_counter_R_C_2 <= time0_5ms;/**/
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_2ms;/**/
					cnt_counter_L_C_2 <= time0_5ms;/**/
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_2ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;
					cnt_counter_R_A_2 <= time0_7ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time0_7ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time3s && cnt_state < time4s)begin //4
					cnt_counter_L_A_1 <= time0_7ms;/**/
					cnt_counter_L_A_2 <= time0_7ms;/**/
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_2ms;/**/
					cnt_counter_R_C_2 <= time0_6ms;/**/
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time0_7ms;/**/
					cnt_counter_L_C_2 <= time0_7ms;/**/
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_2ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;
					cnt_counter_R_A_2 <= time0_7ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time0_7ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time4s && cnt_state < time5s)begin //5
					cnt_counter_L_A_1 <= time0_7ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_2ms;
					cnt_counter_R_C_2 <= time0_6ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_2ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_2ms;
					cnt_counter_L_B_2 <= time0_5ms;/**/
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;
					cnt_counter_R_A_2 <= time0_5ms;/**/
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time0_7ms;
					cnt_counter_R_B_2 <= time0_5ms;/**/
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time5s && cnt_state < time6s)begin  //6
					cnt_counter_L_A_1 <= time1_2ms;/**/
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time0_7ms;/**/
					cnt_counter_R_C_2 <= time0_6ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time0_7ms;/**/
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_2ms;
					cnt_counter_L_B_2 <= time0_5ms;/**/
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;
					cnt_counter_R_A_2 <= time0_5ms;/**/
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time0_7ms;
					cnt_counter_R_B_2 <= time0_5ms;/**/
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time6s && cnt_state < time7s)begin //7
					cnt_counter_L_A_1 <= time1_2ms;/**/
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time0_7ms;/**/
					cnt_counter_R_C_2 <= time0_6ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_2ms;/**/
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time0_7ms;/**/
					cnt_counter_L_B_2 <= time0_5ms;/**/
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_2ms;/**/
					cnt_counter_R_A_2 <= time0_5ms;/**/
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_2ms;/**/
					cnt_counter_R_B_2 <= time0_5ms;/**/
					cnt_counter_R_B_3 <= time2_5ms;
					end
					else if(cnt_state > time7s && cnt_state < time8s)begin //8
					cnt_counter_L_A_1 <= time1_2ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time0_7ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_2ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time0_7ms;/**/
					cnt_counter_L_B_2 <= time0_7ms;/**/
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time0_7ms;/**/
					cnt_counter_R_A_2 <= time0_6ms;/**/
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_2ms;/**/
					cnt_counter_R_B_2 <= time0_7ms;/**/
					cnt_counter_R_B_3 <= time2_5ms;
					end
		   end
			else if(date_flag_2)begin
				if(cnt_state < time1s)begin                               //1
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time1_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_7ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time1s && cnt_state < time1_5s)begin //2
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time1_5s && cnt_state < time2s)begin //3
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time1_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time2_5s && cnt_state < time3s)begin //4
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
			   else if(cnt_state > time3s && cnt_state < time3_5s)begin //5
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time1_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time3_5s && cnt_state < time4s)begin  //6
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time4s && cnt_state < time4_5s)begin //7
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time1_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time4_5s && cnt_state < time5s)begin //8
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time5s && cnt_state < time5_5s)begin //9
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time1_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time5_5s && cnt_state < time6s)begin //10
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
				else if(cnt_state > time6s && cnt_state < time6_5s)begin //11
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time1_5ms;
				end
				else if(cnt_state > time6_5s && cnt_state < time7s)begin //12
					cnt_counter_L_A_1 <= time1_5ms;
					cnt_counter_L_A_2 <= time0_7ms;
					cnt_counter_L_A_3 <= time2_5ms;
					
					cnt_counter_R_A_1 <= time1_5ms;
					cnt_counter_R_A_2 <= time0_6ms;
					cnt_counter_R_A_3 <= time2_5ms;
					
					cnt_counter_R_C_1 <= time1_5ms;
					cnt_counter_R_C_2 <= time0_7ms;
					cnt_counter_R_C_3 <= time2_5ms;
					
					
					cnt_counter_L_B_1 <= time1_5ms;
					cnt_counter_L_B_2 <= time0_7ms;
					cnt_counter_L_B_3 <= time2_5ms;
					
					cnt_counter_L_C_1 <= time1_5ms;
					cnt_counter_L_C_2 <= time0_7ms;
					cnt_counter_L_C_3 <= time2_5ms;
					
					cnt_counter_R_B_1 <= time1_5ms;
					cnt_counter_R_B_2 <= time0_7ms;
					cnt_counter_R_B_3 <= time2_5ms;
				end
		   end
			if(date_flag_1)begin
				cnt_counter_L_A_1 <= time1_5ms;
				cnt_counter_L_A_2 <= time0_7ms;
				cnt_counter_L_A_3 <= time2_5ms;
				
				cnt_counter_L_B_1 <= time1_5ms;
				cnt_counter_L_B_2 <= time0_7ms;
				cnt_counter_L_B_3 <= time2_5ms;
				
				cnt_counter_L_C_1 <= time1_5ms;
				cnt_counter_L_C_2 <= time0_7ms;
				cnt_counter_L_C_3 <= time2_5ms;
				
				
				
				cnt_counter_R_A_1 <= time1_5ms;
				cnt_counter_R_A_2 <= time0_6ms;
				cnt_counter_R_A_3 <= time2_5ms;
				
				cnt_counter_R_B_1 <= time1_5ms;
				cnt_counter_R_B_2 <= time0_7ms;
				cnt_counter_R_B_3 <= time2_5ms;
				
				cnt_counter_R_C_1 <= time1_5ms;
				cnt_counter_R_C_2 <= time0_7ms;
				cnt_counter_R_C_3 <= time2_5ms;
			end
			if(date_flag_1)begin
				if(cnt_state < time1s)begin
					cnt_counter_1 <= time1_5ms;
					cnt_counter_2 <= time0_5ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time1s && cnt_state < time2s)begin
					cnt_counter_1 <= time0_5ms;
					cnt_counter_2 <= time0_5ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time2s && cnt_state < time3s)begin
					cnt_counter_1 <= time0_5ms;
					cnt_counter_2 <= time0_7ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time3s && cnt_state < time4s)begin
					cnt_counter_1 <= time2_0ms;
					cnt_counter_2 <= time0_7ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time4s && cnt_state < time5s)begin
					cnt_counter_1 <= time2_0ms;
					cnt_counter_2 <= time0_7ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time5s && cnt_state < time6s)begin
					cnt_counter_1 <= time2_0ms;
					cnt_counter_2 <= time0_5ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time6s && cnt_state < time7s)begin
					cnt_counter_1 <= time1_5ms;
					cnt_counter_2 <= time0_5ms;
					cnt_counter_3 <= time2_5ms;
				end
				else if(cnt_state > time7s && cnt_state < time8s)begin
					cnt_counter_1 <= time1_5ms;
					cnt_counter_2 <= time0_7ms;
					cnt_counter_3 <= time2_5ms;
				end
		   end
			if(date_flag_2)begin
				cnt_counter_1 <= time1_5ms;
				cnt_counter_2 <= time0_7ms;
				cnt_counter_3 <= time2_5ms;
			end
		end
	end
	
	/*-----------------ģ--------------*/
	always @(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
			date_flag_1   <= 1'b0;
			date_flag_2   <= 1'b0;
			date_flag_3   <= 1'b0;
			date_flag_all <= 1'b0;
		end
		else begin
			if(uart_date == 49)begin
				date_flag_1 <= 1'b1;
			end
			else if(uart_date == 51)begin
				date_flag_1 <= 1'b0;
			end
			else if(uart_date == 52)begin
				date_flag_2 <= 1'b1;
			end
			else if(uart_date == 54)begin
				date_flag_2 <= 1'b0;
			end
			else if(uart_date == 55)begin
				date_flag_3 <= 1'b1;
			end
			else if(uart_date == 57)begin
				date_flag_3 <= 1'b0;
			end
			if(date_flag_1 || date_flag_2 || date_flag_3)begin
				date_flag_all <= 1'b1;
			end
			else if ( !(date_flag_1 || date_flag_2 || date_flag_3))begin
				date_flag_all <= 1'b0;
			end
			else if(uart_date == 58)begin
				date_flag_4 <= 1'b1;
			end
			else if(uart_date == 60)begin
				date_flag_4 <= 1'b0;
			end
			else if(uart_date == 61)begin
				date_flag_5 <= 1'b1;
			end
			else if(uart_date == 63)begin
				date_flag_5 <= 1'b0;
			end
			else if(uart_date == 64)begin
				date_flag_6 <= 1'b1;
			end
			else if(uart_date == 65)begin
				date_flag_6 <= 1'b0;
			end
			else begin
				date_flag_1   <= date_flag_1;
				date_flag_2   <= date_flag_2;
				date_flag_3   <= date_flag_3;
				date_flag_4   <= date_flag_4;
				date_flag_5   <= date_flag_5;
				date_flag_6   <= date_flag_6;
				date_flag_all <= date_flag_all;
			end
		end
	end
	
endmodule    //arm_pwm

