module top_robort_arm(
	clk,
	rst_n,
	uart_rxd,
	uart_txd,
	pwmL_A_1,
	pwmL_A_2,
	pwmL_A_3,
	pwmL_B_1,
	pwmL_B_2,
	pwmL_B_3,
	pwmL_C_1,
	pwmL_C_2,
	pwmL_C_3,
	pwmR_A_1,
	pwmR_A_2,
	pwmR_A_3,
	pwmR_B_1,
	pwmR_B_2,
	pwmR_B_3,
	pwmR_C_1,
	pwmR_C_2,
	pwmR_C_3,
	pwm2,
	pwm3,
	pwm4,
	pwm5,
	pwm1,
	pwm6);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input uart_rxd;
	output uart_txd;
	output pwmL_A_1;
	output pwmL_A_2;
	output pwmL_A_3;
	output pwmL_B_1;
	output pwmL_B_2;
	output pwmL_B_3;
	output pwmL_C_1;
	output pwmL_C_2;
	output pwmL_C_3;
	output pwmR_A_1;
	output pwmR_A_2;
	output pwmR_A_3;
	output pwmR_B_1;
	output pwmR_B_2;
	output pwmR_B_3;
	output pwmR_C_1;
	output pwmR_C_2;
	output pwmR_C_3;
	output pwm2;
	output pwm3;
	output pwm4;
	output pwm5;
	output pwm1;
	output pwm6;

	wire clk;
	wire rst_n;
	wire uart_rxd;
	wire uart_txd;
	wire pwmL_A_1;
	wire pwmL_A_2;
	wire pwmL_A_3;
	wire pwmL_B_1;
	wire pwmL_B_2;
	wire pwmL_B_3;
	wire pwmL_C_1;
	wire pwmL_C_2;
	wire pwmL_C_3;
	wire pwmR_A_1;
	wire pwmR_A_2;
	wire pwmR_A_3;
	wire pwmR_B_1;
	wire pwmR_B_2;
	wire pwmR_B_3;
	wire pwmR_C_1;
	wire pwmR_C_2;
	wire pwmR_C_3;
	wire pwm2;
	wire pwm3;
	wire pwm4;
	wire pwm5;
	wire pwm1;
	wire pwm6;
	wire [7:0] uart_ctrl2_uart_date;
	wire uart_ctrl2_uart_done;
	wire [7:0] uart_loop3_send_date;
	wire uart_loop3_send_en;

	//----Code starts here: integrated by Robei-----
	wire       uart_recv_done;             
	wire [7:0] uart_recv_data;
	wire       uart_send_en;     
	wire [7:0] uart_send_data;   
	wire       uart_tx_busy;     
	
	
	parameter  clk_freq = 50_000_000;
	parameter  uart_bps = 9600;
	
	
	
	//---Module instantiation---
	arm_pwm arm_pwm1(
		.clk(clk),
		.rst_n(rst_n),
		.uart_date(uart_ctrl2_uart_date),
		.pwmL_A_1(pwmL_A_1),
		.pwmL_A_2(pwmL_A_2),
		.pwmL_A_3(pwmL_A_3),
		.pwmL_B_1(pwmL_B_1),
		.pwmL_B_2(pwmL_B_2),
		.pwmL_B_3(pwmL_B_3),
		.pwmL_C_1(pwmL_C_1),
		.pwmL_C_2(pwmL_C_2),
		.pwmL_C_3(pwmL_C_3),
		.pwmR_A_1(pwmR_A_1),
		.pwmR_A_2(pwmR_A_2),
		.pwmR_A_3(pwmR_A_3),
		.pwmR_B_1(pwmR_B_1),
		.pwmR_B_2(pwmR_B_2),
		.pwmR_B_3(pwmR_B_3),
		.pwmR_C_1(pwmR_C_1),
		.pwmR_C_2(pwmR_C_2),
		.pwmR_C_3(pwmR_C_3),
		.pwm1(pwm1),
		.pwm2(pwm2),
		.pwm3(pwm3),
		.pwm4(pwm4),
		.pwm5(pwm5),
		.pwm6(pwm6));

	uart_ctrl uart_ctrl2(
		.clk(clk),
		.rst_n(rst_n),
		.uart_rxd(uart_rxd),
		.uart_done(uart_ctrl2_uart_done),
		.uart_date(uart_ctrl2_uart_date));

	uart_loop uart_loop3(
		.clk(clk),
		.rst_n(rst_n),
		.ctrl_done(uart_ctrl2_uart_done),
		.ctrl_date(uart_ctrl2_uart_date),
		.send_en(uart_loop3_send_en),
		.send_date(uart_loop3_send_date));

	uart_send uart_send4(
		.uart_din(uart_loop3_send_date),
		.uart_en(uart_loop3_send_en),
		.uart_txd(uart_txd));

endmodule    //top_robort_arm

