module uart_loop(
	clk,
	rst_n,
	ctrl_done,
	ctrl_date,
	tx_busy,
	send_en,
	send_date);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input ctrl_done;
	input [7:0] ctrl_date;
	input tx_busy;
	output send_en;
	output [7:0] send_date;

	wire clk;
	wire rst_n;
	wire ctrl_done;
	wire [7:0] ctrl_date;
	wire tx_busy;
	reg send_en;
	reg [7:0] send_date;

	//----Code starts here: integrated by Robei-----
	reg ctrl_done_d0;
	reg ctrl_done_d1;
	reg tx_ready;
	
	wire ctrl_done_flag;
	
	assign ctrl_done_flag = ctrl_done_d0 && (~ctrl_done_d1);
	
	always @(posedge clk or negedge rst_n)begin
	    if(!rst_n)begin
	        ctrl_done_d0 <= 1'd0;
	        ctrl_done_d1 <= 1'd0;
	    end
	    else begin
	        ctrl_done_d0 <= ctrl_done;
	        ctrl_done_d1 <= ctrl_done_d0;
	    end
	end
	
	always @(posedge clk or negedge rst_n)begin
	    if(!rst_n)begin
	        tx_ready  <= 1'b0;
	        send_en   <= 1'b0;
	        send_date <= 8'd0;
	    end
	    else begin
	        if(ctrl_done_flag)begin
	            tx_ready  <= 1'b1;
	            send_en   <= 1'b0;
	            send_date <= ctrl_date;
	        end
	        else if(tx_ready && (~tx_busy))begin
	            send_en   <= 1'b1;
	            tx_ready  <= 1'b0;
	        end 
	    end    
	end
	
	
	
endmodule    //uart_loop

