module uart_send(
	sys_clk,
	sys_rst_n,
	uart_en,
	uart_din,
	uart_txd);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input uart_en;
	input [7:0] uart_din;
	output uart_txd;

	wire sys_clk;
	wire sys_rst_n;
	wire uart_en;
	wire [7:0] uart_din;
	reg uart_txd;

	//----Code starts here: integrated by Robei-----
	
	//parameter define
	parameter  CLK_FREQ = 50000000;             //ϵͳʱƵ
	parameter  UART_BPS = 9600;                 //ڲ
	localparam BPS_CNT  = CLK_FREQ/UART_BPS;    //ΪõָʣϵͳʱӼBPS_CNT
	
	//reg define
	reg        uart_en_d0; 
	reg        uart_en_d1;  
	reg [15:0] clk_cnt;                         //ϵͳʱӼ
	reg [ 3:0] tx_cnt;                          //ݼ
	reg        tx_flag;                         //͹̱־ź
	reg [ 7:0] tx_data;                         //Ĵ淢
	
	//wire define
	wire       en_flag;
	
	//uart_enأõһʱڵź
	assign en_flag = (~uart_en_d1) & uart_en_d0;
	                                                 
	//Էʹźuart_enӳʱ
	always @(posedge sys_clk or negedge sys_rst_n) begin         
	    if (!sys_rst_n) begin
	        uart_en_d0 <= 1'b0;                                  
	        uart_en_d1 <= 1'b0;
	    end                                                      
	    else begin                                               
	        uart_en_d0 <= uart_en;                               
	        uart_en_d1 <= uart_en_d0;                            
	    end
	end
	
	//źen_flagʱ,Ĵ͵ݣ뷢͹          
	always @(posedge sys_clk or negedge sys_rst_n) begin         
	    if (!sys_rst_n) begin                                  
	        tx_flag <= 1'b0;
	        tx_data <= 8'd0;
	    end 
	    else if (en_flag) begin                 //⵽ʹ                      
	            tx_flag <= 1'b1;                //뷢͹̣־λtx_flag
	            tx_data <= uart_din;            //Ĵ͵
	        end
	        else 
	        if ((tx_cnt == 4'd9)&&(clk_cnt == BPS_CNT/2))
	        begin                               //ֹͣλмʱֹͣ͹
	            tx_flag <= 1'b0;                //͹̽־λtx_flag
	            tx_data <= 8'd0;
	        end
	        else begin
	            tx_flag <= tx_flag;
	            tx_data <= tx_data;
	        end 
	end
	
	//뷢͹̺ϵͳʱӼ뷢ݼ
	always @(posedge sys_clk or negedge sys_rst_n) begin         
	    if (!sys_rst_n) begin                             
	        clk_cnt <= 16'd0;                                  
	        tx_cnt  <= 4'd0;
	    end                                                      
	    else if (tx_flag) begin                 //ڷ͹
	        if (clk_cnt < BPS_CNT - 1) begin
	            clk_cnt <= clk_cnt + 1'b1;
	            tx_cnt  <= tx_cnt;
	        end
	        else begin
	            clk_cnt <= 16'd0;               //ϵͳʱӼһں
	            tx_cnt  <= tx_cnt + 1'b1;       //ʱݼ1
	        end
	    end
	    else begin                              //͹̽
	        clk_cnt <= 16'd0;
	        tx_cnt  <= 4'd0;
	    end
	end
	
	//ݷݼuartͶ˿ڸֵ
	always @(posedge sys_clk or negedge sys_rst_n) begin        
	    if (!sys_rst_n)  
	        uart_txd <= 1'b1;        
	    else if (tx_flag)
	        case(tx_cnt)
	            4'd0: uart_txd <= 1'b0;         //ʼλ 
	            4'd1: uart_txd <= tx_data[0];   //λλ
	            4'd2: uart_txd <= tx_data[1];
	            4'd3: uart_txd <= tx_data[2];
	            4'd4: uart_txd <= tx_data[3];
	            4'd5: uart_txd <= tx_data[4];
	            4'd6: uart_txd <= tx_data[5];
	            4'd7: uart_txd <= tx_data[6];
	            4'd8: uart_txd <= tx_data[7];   //λλ
	            4'd9: uart_txd <= 1'b1;         //ֹͣλ
	            default: ;
	        endcase
	    else 
	        uart_txd <= 1'b1;                   //ʱͶ˿Ϊߵƽ
	end       
	
	
	
endmodule    //uart_send

